#include<hypercube.h>
extern "C" {
#include "seplib.h"
}

void hypercube::init_nd(int nd, axis *ax){
  this->ndim=nd;
  this->axes=new axis[ndim];
  this->n123=1;
  for(int i=0; i < ndim; i++){   
     this->axes[i]=ax[i];
     this->n123=this->n123*(long long)ax[i].n;
  }
}

void hypercube::set_axis(int idim, axis myaxis){
  if(idim<1 || idim >this->ndim) {
    fprintf(stderr,"IDIM=%d NDIM=%d \n",idim,this->ndim);
    seperr("GET_AXIS ERROR\n");
  }
  this->axes[idim-1]=myaxis;
}
void hypercube::set_axes(int ndim, axis *axes){
  this->init_nd(ndim,axes);
}

axis *hypercube::return_axes(int nmax) const{
  axis *ax=new axis[nmax];
  for(int i=0; i < nmax; i++){
    if(i+1 <= this->ndim){
       ax[i]=this->axes[i];
    }
    else {
      ax[i]=axis(1);
    }
  }
  return ax;
}
axis hypercube::get_axis(int idim){

  if(idim<1 || idim >this->ndim) {
    fprintf(stderr,"IDIM=%d NDIM=%d \n",idim,this->ndim);
    seperr("GET_AXIS ERROR\n");
  }
  axis myaxis=this->axes[idim-1];
  return myaxis;
}
int hypercube::get_ndim_g1()
{
int nd=this->ndim;
for(int i=this->ndim-1; i>=0; i--){
   if(axes[i].n>1) return nd;
    nd--;
}



}


int *hypercube::return_ns()
{
  int i;
  int *n=new int[this->ndim];
  for(i=0; i < this->ndim; i++) n[i]=this->axes[i].n;
  return n;
}

bool hypercube::same_size(hypercube *other)
{
  if(this->get_ndim() != other->get_ndim()) return false;
  for(int i=0; i < this->get_ndim(); i++){
    axis ax1=this->get_axis(i+1);
    axis ax2=other->get_axis(i+1);
    if(ax1.n!=ax2.n) return false; 
  }
  return true;
}
