#include<hypercube_float.h>
#include<math.h>
#include <cstdlib>

hypercube_float::hypercube_float(int ndim,axis *axes,bool alloc){
  this->init_nd(ndim,axes);
  if(alloc) this->vals=new float[this->get_n123()];
  else this->vals=0;
   

}
hypercube_float::hypercube_float(hypercube *hyper){
  int n=hyper->get_ndim();
  axis *axes=hyper->return_axes(n);
  this->init_nd(n,axes);
  this->vals=new float [this->get_n123()];
  delete [] axes;
}
hypercube_float::hypercube_float(int ndim,axis *axes, float *vals){

  this->init_nd(ndim,axes);
  this->vals=new float[this->get_n123()];
  this->set(vals);

}
hypercube_float *hypercube_float::clone(bool alloc){
 int ndims=this->get_ndim();
 axis axes[ndims];
 for(int i=0; i< ndims; i++) axes[i]=get_axis(i+1);
 hypercube_float *tmp=new hypercube_float(ndims,axes,alloc);
 if(alloc && this->vals!=0) for(int i=0; i< get_n123(); i++) tmp->vals[i]=this->vals[i];
 return tmp;
}
void hypercube_float::add(hypercube_float *vec){

  for(int i=0; i < get_n123(); i++) vals[i]+=vec->vals[i];
}
double hypercube_float::dot(hypercube_float *vec){
  double dp=0.;

  for(int i=0; i < get_n123(); i++) dp+=vals[i]*vec->vals[i];
  return dp;
}
void hypercube_float::set(float *array){

       memcpy((void*)this->vals,(const void*) array, 
         sizeof(float)*this->get_n123());

}
void hypercube_float::set_val(double val){
  for(int i=0; i < this->get_n123(); i++) this->vals[i]=val;
}
void hypercube_float::normalize(float val){
 float mymax=vals[0];

 for(int i=1; i< get_n123(); i++){
 
   if(mymax < vals[i]) mymax=vals[i];
 }
 float sc;
 sc=val/mymax;

 for(int i=0; i< get_n123(); i++){
   vals[i]=vals[i]*sc;
   
  }

}
void hypercube_float::info(char *str){
 double sm,mymin,mymax;
 mymax=mymin=vals[0];
 int imin,imax;
 for(int i=0; i < get_n123(); i++){
   if(mymin > vals[i]) {mymin=vals[i]; imin=i;}
   if(mymax < vals[i]) {mymax=vals[i]; imax=i;}
   sm+=vals[i]*vals[i];
  }
  fprintf(stderr,"%s: NDIMS=%d",str,get_ndim());
  for(int i=0; i < get_ndim(); i++) fprintf(stderr," n%d=%d",i+1,get_axis(i+1).n);
  fprintf(stderr,"\nN=%d min(%d)=%g max(%d)=%g RMS=%g   \n",
      (int)get_n123(), imin,mymin,imax,mymax,sqrt(sm)/(1.0*get_n123()),this->vals[0]);


}
my_vector *hypercube_float::clone_vec(){
  //my_vector *m=(my_vector*) this->clone();
  hypercube_float *m=this->clone();

  return (my_vector*)m;
}
my_vector *hypercube_float::clone_space(){
  //my_vector *m=(my_vector*) this->clone();
  hypercube_float *m=this->clone(false);

  return (my_vector*)m;
}
void hypercube_float::random(){
  for(int i=0; i < get_n123(); i++){
    vals[i]=(float)rand()/(float)RAND_MAX-.5;
  }
}
double hypercube_float::dot(my_vector *other){
  double ret=0;
  check_same(other);
  hypercube_float *o=(hypercube_float*) other;
  for(int i=0; i < get_n123(); i++)  ret+=this->vals[i]*o->vals[i];
  return ret;
}
void hypercube_float::scale_add(double scale_me, my_vector *other, 
double scale_other){
  check_same(other);
  hypercube_float *o=(hypercube_float*) other;
  for(int i=0; i< get_n123();i++) this->vals[i]=this->vals[i]*scale_me+
    scale_other*o->vals[i];
  
}
void hypercube_float::add(my_vector *other){
  check_same(other);
  hypercube_float *o=(hypercube_float*) other;
  for(int i=0; i < get_n123(); i++) this->vals[i]+=o->vals[i];
}